unit demomain;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms,spin, Dialogs, Buttons, Grids, spread, ExtCtrls,stdctrls,framefrm,
  Gauges;

type
  Tdemospread = class(TForm)
    Bevel1: TBevel;
    Spread1: TSpread;
    btnexit: TSpeedButton;
    btnputbitmap: TSpeedButton;
    OpenDialog1: TOpenDialog;
    btnclearbitmap: TSpeedButton;
    btnchkbox: TSpeedButton;
    btncombo: TSpeedButton;
    btnbutton: TSpeedButton;
    btnspinedit: TSpeedButton;
    SpeedButton1: TSpeedButton;
    btnframe: TSpeedButton;
    btnbrush: TSpeedButton;
    ColorDialog1: TColorDialog;
    btncolbrush: TSpeedButton;
    btnrowbrush: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    btnCellfont: TSpeedButton;
    FontDialog1: TFontDialog;
    btncolfont: TSpeedButton;
    btnrowfont: TSpeedButton;
    btnleftalign: TSpeedButton;
    btncenter: TSpeedButton;
    btnrightalign: TSpeedButton;
    btnaddrow: TSpeedButton;
    SpeedButton4: TSpeedButton;
    btninsertrow: TSpeedButton;
    btninsertcol: TSpeedButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    procedure btnexitClick(Sender: TObject);
    procedure btnputbitmapClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnclearbitmapClick(Sender: TObject);
    procedure btnchkboxClick(Sender: TObject);
    procedure btncomboClick(Sender: TObject);
    procedure btnbuttonClick(Sender: TObject);
    procedure btnspineditClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure btnframeClick(Sender: TObject);
    procedure btnbrushClick(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure btnCellfontClick(Sender: TObject);
    procedure btnleftalignClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure btnaddrowClick(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure btninsertrowClick(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Spread1CellTypeViol(icol, irow: Longint; Celltype,
      CellEntrytype: Tctype; cellstring: String;
      var NewCellstring: OpenString; var changecelltype: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  demospread: Tdemospread;

implementation

{$R *.DFM}

procedure Tdemospread.btnexitClick(Sender: TObject);
begin
     Application.Terminate;
end;

procedure Tdemospread.btnputbitmapClick(Sender: TObject);
var
   Bmp : TBitmap;
begin

     If opendialog1.execute then
     begin
       Bmp := TBitmap.create;
       Bmp.Loadfromfile(opendialog1.filename);
       Spread1.Putbitmap(Spread1.col,Spread1.row,Bmp);
     end;

end;

procedure Tdemospread.FormCreate(Sender: TObject);
var
   c,r : longint;
begin
     Spread1.initialize;

end;

procedure Tdemospread.btnclearbitmapClick(Sender: TObject);
begin
     With spread1 do
       Clearbitmap(col,row);
end;

procedure Tdemospread.btnchkboxClick(Sender: TObject);
var
   T : TCheckbox;
begin
     With Spread1 do
     begin
       MakeCheckbox(col,row,'C',true);
       T := GetCellCheckbox(col,row);
       If T <> nil then
       begin
         T.Caption := 'Test';
         T.Font.style := T.Font.style + [fsbold];
         T.checked := false;
       end;
     end;

end;

procedure Tdemospread.btncomboClick(Sender: TObject);
var
    T : TCombobox;
begin
     With Spread1 do
     begin
       Makecombobox(col,row,csdropdown);
       T := GetCellcombobox(col,row);
       If T = nil then exit;

       T.items.add('one');
       T.items.add('two');
       T.items.add('three');
       T.items.add('four');
       T.items.add('five');
       T.items.add('six');
       T.items.add('seven');
       T.items.add('eight');
       T.items.add('nine');
       T.items.add('ten');
       T.text := '';
       T.itemindex := 4;
     end;
end;

procedure Tdemospread.btnbuttonClick(Sender: TObject);
var
   T : TButton;
begin
     With Spread1 do
     begin
       Makebutton(col,row,'Ok');
       T := GetCellbutton(col,row);
       If T = nil then exit;
       T.Font.style := T.Font.style + [fsbold,fsitalic];
       T.Font.color := clred;
     end;
end;

procedure Tdemospread.btnspineditClick(Sender: TObject);
begin
     with spread1 do
       Makespinedit(col,row,1);
end;

procedure Tdemospread.SpeedButton1Click(Sender: TObject);
begin
     with spread1 do
     begin
       Removecombobox(col,row);
       Removecheckbox(col,row);
       Removebutton(col,row);
       removespinedit(col,row);
     end;
end;

procedure Tdemospread.btnframeClick(Sender: TObject);
var
   Tc : Tcframe;
   T : TPenstyle;
   clr : Tcolor;
   w : integer;
begin
     Tc := [];
     With frameform do
     begin
       showmodal;
       if modalresult = mrok then
       begin
         If frameleft.checked then
           Tc := Tc + [cfleft];
         If frameright.checked then
           Tc := Tc + [cfright];
         If frametop.checked then
           Tc := Tc + [cftop];
         If framebottom.checked then
           Tc := Tc + [cfbottom];
         If frameoutline.checked then
           Tc := [cfoutline];
         case listbox1.itemindex of
         0 : T := PsSolid;
         1 : T := psDash;
         2 : T := psDashDot;
         3 : T := psDashDotDot;
         4 : T := psDot;
         5 : T := psClear;
         6 : T := psInsideFrame;
         end;
         clr := colorgrid1.foregroundcolor;
         w := spinedit1.value;
         Spread1.SetCellframe(Spread1.col,Spread1.row,Tc,clr,w,T);
       end;
     end;

end;

procedure Tdemospread.btnbrushClick(Sender: TObject);
var
   Br : TBrush;
begin
     if colordialog1.execute then
     begin
       Br := TBrush.create;
       Br.color := colordialog1.color;
       If Sender = btnbrush then
         Spread1.setcellbrush(spread1.col,spread1.row,Br)
       else if Sender = btncolbrush then
         Spread1.setcolBrush(spread1.col,Br)
       else if Sender = btnrowbrush then
         Spread1.setrowBrush(spread1.row,Br);

     end;
end;

procedure Tdemospread.SpeedButton2Click(Sender: TObject);
begin
     With Spread1 do
       LockCell(col,row);
end;

procedure Tdemospread.SpeedButton3Click(Sender: TObject);
begin
     With Spread1 do
       UnlockAllCells;
end;

procedure Tdemospread.btnCellfontClick(Sender: TObject);
var
   F : TFont;
begin
     If fontdialog1.execute then
     begin
       F := TFont.Create;
       F := fontdialog1.font;
       If Sender = btncellfont then
         Spread1.setcellfont(Spread1.col,Spread1.row,F)
       else if Sender = btncolfont then
         Spread1.setcolfont(Spread1.col,F)
       else if Sender = btnrowfont then
         Spread1.setrowfont(Spread1.row,F);

     end;
end;

procedure Tdemospread.btnleftalignClick(Sender: TObject);
var
   T : TAlignment;
begin
     If Sender = btnleftalign then
       T := taLeftJustify
     else if Sender = btnrightalign then
       T := taRightJustify
     else if Sender = btncenter then
       T := taCenter;
     With Spread1 do
       SetCellAlignment(col,row,T);
end;

procedure Tdemospread.Button2Click(Sender: TObject);
var
   T : TCheckbox;
begin
     T := Spread1.GetCellCheckbox(Spread1.col,Spread1.row);
     If T <> nil then
       T.checked := not T.checked;
end;

procedure Tdemospread.Button3Click(Sender: TObject);
var
   T : TButton;
begin
     T := Spread1.GetCellButton(Spread1.col,Spread1.row);
     If T <> nil then
       T.enabled := not T.enabled;
end;

procedure Tdemospread.Button4Click(Sender: TObject);
var
    T : TSpinedit;
begin
     T := spread1.getcellspinedit(spread1.col,spread1.row);
     if T <> nil then
       T.value := T.value + 1;
end;

procedure Tdemospread.btnaddrowClick(Sender: TObject);
begin
     Spread1.AddRow;
end;

procedure Tdemospread.SpeedButton4Click(Sender: TObject);
begin
     spread1.Addcol;
end;

procedure Tdemospread.btninsertrowClick(Sender: TObject);
begin
     if Sender = btninsertrow then
       Spread1.InsertRow(Spread1.row)
     else if Sender = btninsertcol then
       Spread1.insertcol(Spread1.col);
end;

procedure Tdemospread.Button5Click(Sender: TObject);
begin
     With Spread1 do
       deleterow(row);
end;

procedure Tdemospread.Button6Click(Sender: TObject);
begin
     With Spread1 do
       deletecol(col);
end;

procedure Tdemospread.Button7Click(Sender: TObject);
begin
     Screen.cursor := crhourglass;
     Spread1.recalculate;
     Screen.cursor := crdefault;
end;

procedure Tdemospread.Spread1CellTypeViol(icol, irow: Longint; Celltype,
  CellEntrytype: Tctype; cellstring: String; var NewCellstring: OpenString;
  var changecelltype: Boolean);
begin
     changecelltype := true;
end;

end.
